'use strict';Object.defineProperty(exports, "__esModule", { value: true });var _assert = require('assert');var _assert2 = _interopRequireDefault(_assert);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

class ErrorMapper {
  constructor() {
    this.errorMaps = {};
  }

  addHandler(handler) {
    if (typeof handler === 'object') {
      const keys = Object.keys(handler);
      keys.forEach(key => this.addHandler(handler[key]));
    }

    (0, _assert2.default)(handler.getCode, 'Expecting handler to have static getCode method.');
    Object.assign(this.errorMaps, { [handler.getCode()]: handler });
  }

  /**
     * Determines whether the name has an error associated.
     * @param name
     * @returns {boolean}
     */
  hasError(name) {
    return !!this.errorMaps[name];
  }

  /**
     * Returns a new instance of error associated to the name.
     * @param name
     * @param args
     */
  error(name, args) {
    return new this.errorMaps[name](args);
  }}exports.default = ErrorMapper;